Combination Sum —— LeetCode

Given a set of candidate numbers (C) and a target number (T), find all unique combinations in C where the candidate numbers sums to T.

The same repeated number may be chosen from C unlimited number of times.

Note:

  • All numbers (including target) will be positive integers.
  • Elements in a combination (a1, a2, … , ak) must be in non-descending order. (ie, a1 ≤ a2 ≤ … ≤ ak).
  • The solution set must not contain duplicate combinations.

 

For example, given candidate set 2,3,6,7 and target 7
A solution set is: 
[7] 
[2, 2, 3] 

题目大意:给一个候选数组,一个目标值,从候选数组找出所有和等于目标值的List,候选数组元素可以重复。

解题思路:还是用回溯的方式来做,因为可以重复,所以每次都可以从当前元素开始往后依次添加到List,递归判断,然后回溯。

    public List<List<Integer>> combinationSum(int[] candidates, int target) {

        List<List<Integer>> res = new ArrayList<>();

        if (candidates == null || candidates.length == 0) {

            return res;

        }

        List<Integer> tmp = new ArrayList<>();

        helper(res, tmp, 0,candidates, target);

        return res;

    }



    private void helper(List<List<Integer>> res, List<Integer> tmp, int start,int[] candidates, int target) {

        if (0 == target) {

            res.add(new ArrayList<>(tmp));

//            System.out.println(tmp);

            return;

        }

        for (int i = start; i < candidates.length && target >= candidates[i]; i++) {

            tmp.add(candidates[i]);

            helper(res, tmp, i,candidates, target - candidates[i]);

            tmp.remove(tmp.size() - 1);

            int ca = candidates[i];

            while(i<candidates.length&&ca==candidates[i]){

                i++;

            }

        }

    }

 

你可能感兴趣的:(LeetCode)